#ifndef STREETSMODEL_H
#define STREETSMODEL_H

#include <QAbstractItemModel>
#include <QtSql>

class StreetsModel : public QAbstractItemModel
{
    Q_OBJECT

private:
    enum DBTables { CityesTable, StreetsTable, OrganizationsTable };

    struct InternalId
    {
        DBTables table;
        QModelIndex parentIndex;
        int row;
        int column;

        bool operator==( InternalId &other ) const
        { return row == other.row && column == other.column && table == other.table && parentIndex == other.parentIndex; }
    };

    mutable QList<InternalId> m_internalIds;

    QSqlRelationalTableModel *m_cityesModel;
    QSqlRelationalTableModel *m_streetsModel;
    QSqlRelationalTableModel *m_organizationsModel;


    void setCityesFilter( const QString &cityId ) const;
    void setStreetFilter( const QString &streetId ) const;

public:
    explicit StreetsModel(QObject *parent = 0);

    virtual int columnCount ( const QModelIndex & parent = QModelIndex() ) const;
    virtual QVariant data ( const QModelIndex & index, int role = Qt::DisplayRole ) const;
    virtual QModelIndex index ( int row, int column, const QModelIndex & parent = QModelIndex() ) const;
    virtual QModelIndex parent ( const QModelIndex & index ) const;
    virtual int rowCount ( const QModelIndex & parent = QModelIndex() ) const;
    //virtual bool hasChildren ( const QModelIndex & parent = QModelIndex() ) const;
};

#endif // STREETSMODEL_H
